import processing.serial.*;

import cc.arduino.*;
import org.firmata.*;

//creamos un objeto tipo Arduino
Arduino miArduino;

//variable para el led
int L13 = 13;

//variables para el potenciómetro
int pot = 0;
int valorPot;
int tiempoBlink, tMinimo, tMaximo;

//variables para el medidor rectangular
int x, y, w, h;  //posición y tamaño

void setup(){
  size(300, 100);
  
  w = 250;
  h = 75;
  x = (width - w)/2;
  y = (height - h)/2;
  
  //inicializamos el objetor miArduino
  miArduino = new Arduino(this, Arduino.list()[3], 57600);
  
  miArduino.pinMode(L13, Arduino.OUTPUT);
  tMinimo = 5;
  tMaximo = 500;
  tiempoBlink = 3000;
  
}

void draw(){
  background(255);
  
  //leemos el potenciómetro
  valorPot = miArduino.analogRead(pot);
  println(valorPot);
  
  //encedemos el led
  miArduino.digitalWrite(L13, Arduino.HIGH);
  delay(tiempoBlink);
  
  //apagamos el led
  miArduino.digitalWrite(L13, Arduino.LOW);
  delay(tiempoBlink);
  
  //dibujamos el rectángulo como un medidor de acuerdo al giro del potenciómetro
  //primero, mapeamos el valor del potenciómetro al ancho del rectángulo
  float potenciometro = map(valorPot, 0, 1023, 0, w);
  
  fill(250, 0, 0);
  noStroke();
  rect(x, y, potenciometro, h);
  noFill();
  stroke(0);
  rect(x, y, w, h);
  
  //mapeamos el valor de tiempoBlink de acuerdo al valor del potenciómetro
  tiempoBlink = (int) map(valorPot, 0, 1023, tMinimo, tMaximo);
  
}
  
